unit U_ClothContractListHZ;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ToolWin, cxStyles, cxCustomData,
  cxGraphics, cxFilter, cxData, cxDataStorage, cxEdit, DB, cxDBData, ADODB,
  cxGridCustomPopupMenu, cxGridPopupMenu, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxGrid, DBClient, cxCalendar, cxButtonEdit, cxSplitter,
  RM_Common, RM_Class, RM_e_Xls, RM_Dataset, RM_System, RM_GridReport,
  cxTextEdit, cxPC;

type
  TfrmClothContractListHZ = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    TBDel: TToolButton;
    TBPrint: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    Label1: TLabel;
    Label2: TLabel;
    cxGridPopupMenu1: TcxGridPopupMenu;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    Label3: TLabel;
    ConNoM: TEdit;
    Label5: TLabel;
    C_CodeNameM: TEdit;
    TBExport: TToolButton;
    Order_Main: TClientDataSet;
    Label4: TLabel;
    C_Spec: TEdit;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    CDS_PRT: TClientDataSet;
    ToolButton1: TToolButton;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1OrderNo: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1DeliveryDate: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1FactoryNo1Name: TcxGridDBColumn;
    v1PRTSpec: TcxGridDBColumn;
    v1Qty1: TcxGridDBColumn;
    v1PRTOrderQty: TcxGridDBColumn;
    v1OrderUnit: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1PRTQty: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBPrintClick(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cxPageControl1Change(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
  private
    FInt,PFInt:Integer;
    procedure InitGrid();
    procedure InitForm();
    function  DelData():Boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmClothContractListHZ: TfrmClothContractListHZ;

implementation
uses
  U_DataLink,U_ClothContractInPutSX,U_Fun,U_ProductOrderList,U_ZDYHelp,U_ClothContractInPutSXMX
  ,U_ClothContractInPutHZ,U_ClothContractInPutPB;

{$R *.dfm}

procedure TfrmClothContractListHZ.FormDestroy(Sender: TObject);
begin
  frmClothContractListHZ:=nil;
end;

procedure TfrmClothContractListHZ.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmClothContractListHZ.TBCloseClick(Sender: TObject);
begin

  ReadCxGrid(self.Caption,Tv1,'指示单管理');
  Close;
end;

procedure TfrmClothContractListHZ.InitGrid();
begin
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered:=False;
        Close;
        sql.Clear;
        sql.Add('select A.*,B.* ');
        sql.Add('from Contract_sub A');
        sql.Add('inner join Contract_Main B on B.mainID=A.mainID');
        sql.Add('where  FillTime>='''+Trim(FormatDateTime('yyyy-MM-dd',BegDate.DateTime))+'''');
        sql.Add('and FillTime<'''+Trim(FormatDateTime('yyyy-MM-dd',EndDate.DateTime+1))+'''');
        sql.Add('and FillTime<'''+Trim(FormatDateTime('yyyy-MM-dd',EndDate.DateTime+1))+'''');
        sql.Add('and HTType=''采购合同'' ');
        Open;
      end;
      SCreateCDS20(ADOQueryMain,Order_Main);
      SInitCDSData20(ADOQueryMain,Order_Main);
    finally
      ADOQueryMain.EnableControls;
    end;

end;

procedure TfrmClothContractListHZ.InitForm();
begin
  ReadCxGrid(self.Caption,Tv1,'指示单管理');
  if Trim(DParameters1)='1' then
  begin
    TBPrint.Visible:=False;
    v1Column1.Visible:=False;
    v1Column1.Hidden:=True;
    v1PRTQty.Visible:=False;
    v1PRTQty.Hidden:=True;
  end else
  begin
    v1Column1.Visible:=True;
    v1Column1.Hidden:=False;
    v1PRTQty.Visible:=True;
    v1PRTQty.Hidden:=False;
    TBPrint.Visible:=True;
  end;
  BegDate.DateTime:=SGetServerDate10(ADOQueryTemp)-7;
  EndDate.DateTime:=SGetServerDate10(ADOQueryTemp);
  InitGrid();
end;

procedure TfrmClothContractListHZ.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

procedure TfrmClothContractListHZ.TBEditClick(Sender: TObject);
begin
    try
      frmClothContractInPutPB:=TfrmClothContractInPutPB.Create(Application);
      with frmClothContractInPutPB do
      begin
        PState:=1;
        FMainId:=Trim(Self.Order_Main.fieldbyname('MainId').AsString);
        FConNo:=Trim(Self.Order_Main.fieldbyname('ConNo').AsString);
        if ShowModal=1 then
        begin
          InitGrid();
        end;
      end;
    finally
      frmClothContractInPutPB.Free;
    end;

end;

procedure TfrmClothContractListHZ.TBDelClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;

  if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('delete Contract_Sub where mainID='''+Trim(Order_Main.fieldbyname('mainID').AsString)+'''');
      sql.Add('delete Contract_Main where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      ExecSQL;
    end;
   InitGrid();
end;

function TfrmClothContractListHZ.DelData():Boolean;
begin
  try
    Result:=false;
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('delete ContractSX_Sub where SubId='''+Trim(Order_Main.fieldbyname('SubId').AsString)+'''');
      ExecSQL;
    end;
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from ContractSX_Sub where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      Open;
    end;
    if ADOQueryTemp.IsEmpty then
    begin
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('delete ContractSX_Main where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
        ExecSQL;
      end;
    end;
    if Trim(Order_Main.fieldbyname('SubId').AsString)='' then
    begin
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('delete ContractSX_Main where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
        ExecSQL;
      end;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Result:=False;
    Application.MessageBox('数据删除异常！','提示',0);
  end;
end;

procedure TfrmClothContractListHZ.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  TcxGridToExcel('坯布合同订单列表',cxGrid1);
end;

procedure TfrmClothContractListHZ.TBPrintClick(Sender: TObject);
var
   fPrintFile,FConNoM:string;

begin
  if Order_Main.IsEmpty then Exit;
    fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\坯布订购合同.rmf' ;
    with ADOQueryTemp do
    begin
      Filtered:=False;
      Close;
      sql.Clear;
      sql.Add('select A.*,B.* ');
      sql.Add('from Contract_sub A');
      sql.Add('inner join Contract_Main B on B.mainID=A.mainID');
      sql.Add('where  B.MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      Open;
    end;
    SCreateCDS20(ADOQueryTemp,CDS_PRT);
    SInitCDSData20(ADOQueryTemp,CDS_PRT);

  if FileExists(fPrintFile) then
  begin
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end else
  begin
    Application.MessageBox(PChar('没有找'+trim(fPrintFile)),'提示',0);
  end;

end;

procedure TfrmClothContractListHZ.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmClothContractListHZ.TBAddClick(Sender: TObject);
begin
    try
      frmClothContractInPutPB:=TfrmClothContractInPutPB.Create(Application);
      with frmClothContractInPutPB do
      begin
        PState:=0;
        FMainId:='';
        if ShowModal=1 then
        begin
          InitGrid();
        end;
      end;
    finally
      frmClothContractInPutPB.Free;
    end;
end;

procedure TfrmClothContractListHZ.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

procedure TfrmClothContractListHZ.FormShow(Sender: TObject);
begin
  InitForm();
end;

procedure TfrmClothContractListHZ.cxPageControl1Change(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmClothContractListHZ.ToolButton1Click(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
    try
      frmClothContractInPutPB:=TfrmClothContractInPutPB.Create(Application);
      with frmClothContractInPutPB do
      begin
        PState:=1;
        PCopyInt:=1;
        FMainId:=Trim(Self.Order_Main.fieldbyname('MainId').AsString);
        FConNo:=Trim(Self.Order_Main.fieldbyname('ConNo').AsString);
        if ShowModal=1 then
        begin
          InitGrid();
        end;
      end;
    finally
      frmClothContractInPutPB.Free;
    end;
end;

end.
